package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.CardWithClientsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class CardListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new CardCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new CardUpdater();
	}
	
	public Vector load() {
		Vector list = new Vector();

		try {
			list = CardController.cardList();
		} catch (InternalErrorException e) {}

		return list;
	}
	
	public void delete(Serializable id) {

		try {
			CardController.deleteCard((Long) id);
		} catch (InstanceNotFoundException e) {
		} catch (CardWithClientsException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InternalErrorException e) {
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = CardController.findCard((Long) id);
		} catch (InstanceNotFoundException e) {
        } catch (InternalErrorException e) {}
        return map;
	}
	
}
