package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.InvalidPayModeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAddressException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableBankException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;

public class CompanyCreator extends SaveAdapter {

	public Serializable save(HashMap map) {

		Serializable id = null;
		
		try {

			if (inputTesting(map))				
				
			id = CompanyController.createCompany((Long) map.get("address"), (String) map.get("street"), (String) map.get("dwellingPlace"), 
					(String) map.get("phone1"), (String) map.get("phone2"), (String) map.get("fax"), (String) map.get("email"), (String) map.get("web"), (Long) map.get("bank"), (Long) map.get("card"), (String) map.get("notes"), 
					(String) map.get("cif"), (String) map.get("name"), (String) map.get("representative"), (String) map.get("accountNumber"));
		
		} catch (InvalidPayModeException e) {
			e.printStackTrace();
		} catch (UnaceptableAddressException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));		
		} catch (UnaceptableBankException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("bank"));		
		} catch (InternalErrorException e) {			
			e.printStackTrace();
		} 
		
		return id;
		
	}

	protected boolean inputTesting(HashMap map) {
		
		if (((Long) map.get("address")) == null) {		
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("address"));
			return false;
		}

		if (((String) map.get("name")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("name"));
			return false;
		}				
		
		if (((String) map.get("cif")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("cif"));
			return false;
		}
		
		ErrorsHandler.clear();

		return true;

	}

}
