package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.model.configurationfacade.delegate.ConfigurationFacadeDelegate;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.EmployeeWithWashesException;
import gz.cyberbrain.cyberhotel.model.employee.to.EmployeeTo;
import gz.cyberbrain.cyberhotel.model.spring.facade.SpringFacadeFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

public class EmployeeController {

	private static ConfigurationFacadeDelegate confDelegate = SpringFacadeFactory.getConfigurationFacadeDelegate();
	private static HashMap<String, Object> attributes = new HashMap<String, Object>();

	private EmployeeController() {}

	public static Vector employeeList() {				
		Vector<TextItem> items = new Vector<TextItem>();
		Collection employees;
		try {
			employees = confDelegate.showEmployees();
	
		Iterator iter = employees.iterator();

		EmployeeTo employee;

		for (int i=0; iter.hasNext(); i++) {

			employee = (EmployeeTo) iter.next();
			items.add(new TextItem(employee.getEmployeeId(), employee.getFirstSurname() + " " + employee.getSecondSurname() + ", " + employee.getName()));

		}

		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		
		return items;
	}

	public static Serializable createEmployee(Long employeeId, String nif, String name, String firstSurname, 
			String secondSurname, Calendar bornDate, String sex, String maritalStatus, Long address, String street, 
			String dwellingPlace, String phone1, String phone2, String job, Calendar hireDate, BigDecimal salary, 
			String observations) throws InternalErrorException {
		
		return confDelegate.createEmployee(new EmployeeTo(employeeId,nif,name,firstSurname,secondSurname,bornDate,sex, 
				maritalStatus, address, street, dwellingPlace, phone1, phone2, job, hireDate, salary, observations));
		
	}

	public static void updateEmployee(Long employeeId, String nif, String name, String firstSurname, 
			String secondSurname, Calendar bornDate, String sex, String maritalStatus, Long address, String street, 
			String dwellingPlace, String phone1, String phone2, String job, Calendar hireDate, BigDecimal salary, 
			String observations) throws InternalErrorException {		
		
		confDelegate.updateEmployee(new EmployeeTo(employeeId,nif,name,firstSurname,secondSurname,bornDate,sex, 
				maritalStatus, address, street, dwellingPlace, phone1, phone2, job, hireDate, salary, observations));
	}

	public static void deleteEmployee(Long employeeId) 
	throws EmployeeWithWashesException, InstanceNotFoundException, InternalErrorException {
		
		EmployeeTo employee = confDelegate.findEmployee(employeeId);
		confDelegate.deleteEmployee(employee);
		
	}

	public static HashMap findEmployee(Long employeeId) throws InstanceNotFoundException, InternalErrorException {

		EmployeeTo employee = confDelegate.findEmployee(employeeId);

		attributes.put("id", employeeId);
		attributes.put("nif", employee.getNif());
		attributes.put("name", employee.getName());
		attributes.put("firstSurname", employee.getFirstSurname());
		attributes.put("secondSurname", employee.getSecondSurname());
		attributes.put("bornDate", employee.getBornDate());
		attributes.put("sex", employee.getSex());
		attributes.put("maritalStatus", employee.getMaritalStatus());
		attributes.put("address", employee.getAddress());
		attributes.put("street", employee.getStreet());
		attributes.put("dwellingPlace", employee.getDwellingPlace());
		attributes.put("phone1", employee.getPhone1());
		attributes.put("phone2", employee.getPhone2());
		attributes.put("job", employee.getJob());
		attributes.put("hireDate", employee.getHireDate());
		attributes.put("salary", employee.getSalary());
		attributes.put("observations", employee.getObservations());
		
		return attributes;

	}

}
