package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class IndividualCheckOutListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new CheckOutCreator();
	}
	
	public SaveAdapter getUpdater() {
		ErrorsHandler.clear();
		ErrorsHandler.add(new ErrorItem("update"));
		throw new UnsupportedOperationException();
	}
	
	@SuppressWarnings("unchecked")
	public Vector load() {
		
		Vector aux = new Vector();
		Vector list = new Vector();

		try {
			aux = CheckOutController.checkOutList();
		
			for (int i=0; i < aux.size(); i++) {
			
				if (CheckOutController.reservationRequests((Long) ((TextItem) aux.elementAt(i)).getId()).size() == 1) 
					list.add(aux.elementAt(i));
				
			}
			
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		
		return list;

	}
	
	public void delete(Serializable id) {

		ErrorsHandler.clear();
		ErrorsHandler.add(new ErrorItem("delete"));

		throw new UnsupportedOperationException();
		
	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = CheckOutController.findCheckOut((Long) id);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
        } catch (InternalErrorException e) {
        	e.printStackTrace();
        }
        return map;
	}
	
}
