package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableRoomTypeException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;

public class RoomCreator extends SaveAdapter {

	public Serializable save(HashMap map) {

		Serializable id = null;
		
		try {

			if (inputTesting(map)) 
				id = RoomController.createRoom((String) map.get("code"), (String) map.get("number"), ((Long) map.get("floor")).longValue(), (String) map.get("type"), ((Boolean) map.get("smokers")).booleanValue(), ((Long) map.get("maxPax")).longValue(), (String) map.get("notes"));			

		} catch (UnaceptableRoomTypeException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("type"));
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		return id;
	}

	protected boolean inputTesting(HashMap map) {

		if (((String) map.get("code")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("code"));
			return false;
		}

		if (((String) map.get("number")).trim().equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("number"));
			return false;
		}

		ErrorsHandler.clear();
		
		return true;
	}

}
