package gz.cyberbrain.cyberhotel.model.board.dao;

import gz.cyberbrain.cyberhotel.model.board.to.BoardTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface BoardDao {

	public BoardTo create(BoardTo boardTo) throws InternalErrorException;

	public BoardTo find(String boardCode) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (BoardTo boardTo) 
		throws InternalErrorException;
	
	public void remove(BoardTo boardTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findAllCodes() throws InternalErrorException;
	
	public boolean existRequests (String boardCode) 
		throws InternalErrorException;
	
	public boolean isTariffied (String boardCode)
		throws InternalErrorException;
	
}
