package gz.cyberbrain.cyberhotel.model.client.to;

import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;

import java.util.Calendar;

public class ParticularTo extends ClientTo {
	
	private static final long serialVersionUID = 7530658490167655954L;
	private String name;
	private String firstSurname;
	private String secondSurname;
	private Calendar bornDate;
	private String documentType;
	private String documentNumber;
	private Calendar expeditionDate;
	private Calendar expirationDate;
	private String sex;
	private String nationality;
	private String job;
	private Long company;
	private String payMode;
	private String accountNumber;
	private String cardNumber;
	private String voucherCode;
	private String clientType;
	
	public ParticularTo(){}
	
	public ParticularTo(Long clientId, Long address, String street, String dwellingPlace, String phone1, String phone2, String fax, String email, String web, Long bank, Long card, String notes, String name, String firstSurname, String secondSurname, Calendar bornDate, String documentType, String documentNumber, Calendar expeditionDate, Calendar expirationDate, String sex, String nationality, String job, Long company, String payMode, String accountNumber, String cardNumber, String voucherCode, String clientType) {
		super(clientId, address, street, dwellingPlace, phone1, phone2, fax, email,
				web, bank, card, notes);		
		this.name = name;
		this.firstSurname = firstSurname;
		this.secondSurname = secondSurname;
		this.bornDate = DateOperations.getDateWithoutMilliseconds(bornDate);
		this.documentType = documentType;
		this.documentNumber = documentNumber;
		this.expeditionDate = DateOperations.getDateWithoutMilliseconds(expeditionDate);
		this.expirationDate = DateOperations.getDateWithoutMilliseconds(expirationDate);
		this.sex = sex;
		this.nationality = nationality;
		this.job = job;
		this.company = company;
		this.payMode = payMode;
		this.accountNumber = accountNumber;
		this.cardNumber = cardNumber;
		this.voucherCode = voucherCode;
		this.clientType = clientType;
	}

	public String getAccountNumber() {
		return accountNumber;
	}

	public void setAccountNumber(String accountNumber) {
		this.accountNumber = accountNumber;
	}

	public Calendar getBornDate() {
		return bornDate;
	}

	public void setBornDate(Calendar bornDate) {
		this.bornDate = bornDate;
	}

	public String getCardNumber() {
		return cardNumber;
	}

	public void setCardNumber(String cardNumber) {
		this.cardNumber = cardNumber;
	}

	public String getClientType() {
		return clientType;
	}

	public void setClientType(String clientType) {
		this.clientType = clientType;
	}

	public Long getCompany() {
		return company;
	}

	public void setCompany(Long company) {
		this.company = company;
	}

	public String getDocumentNumber() {
		return documentNumber;
	}

	public void setDocumentNumber(String documentNumber) {
		this.documentNumber = documentNumber;
	}

	public String getDocumentType() {
		return documentType;
	}

	public void setDocumentType(String documentType) {
		this.documentType = documentType;
	}

	public Calendar getExpeditionDate() {
		return expeditionDate;
	}

	public void setExpeditionDate(Calendar expeditionDate) {
		this.expeditionDate = expeditionDate;
	}

	public Calendar getExpirationDate() {
		return expirationDate;
	}

	public void setExpirationDate(Calendar expirationDate) {
		this.expirationDate = expirationDate;
	}

	public String getFirstSurname() {
		return firstSurname;
	}

	public void setFirstSurname(String firstSurname) {
		this.firstSurname = firstSurname;
	}

	public String getJob() {
		return job;
	}

	public void setJob(String job) {
		this.job = job;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getNationality() {
		return nationality;
	}

	public void setNationality(String nationality) {
		this.nationality = nationality;
	}

	public String getPayMode() {
		return payMode;
	}

	public void setPayMode(String payMode) {
		this.payMode = payMode;
	}

	public String getSecondSurname() {
		return secondSurname;
	}

	public void setSecondSurname(String secondSurname) {
		this.secondSurname = secondSurname;
	}

	public String getSex() {
		return sex;
	}

	public void setSex(String sex) {
		this.sex = sex;
	}

	public String getVoucherCode() {
		return voucherCode;
	}

	public void setVoucherCode(String voucherCode) {
		this.voucherCode = voucherCode;
	}
	
	public String getReferenceName() {
		return new String (firstSurname + " " + secondSurname + ", " + name);
	}
		
}
