package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.AddressInUseException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteAddressByLocalityAction {

	private String country;
	private String province;
	private String locality;
	private AddressDao addressDao;

	public DeleteAddressByLocalityAction (String country, String province, String locality, AddressDao addressDao) {

		this.country = country;
		this.province = province;
		this.locality = locality;
		this.addressDao = addressDao;

	}

	public void execute() throws AddressInUseException, InstanceNotFoundException, InternalErrorException {	
		
		AddressTo addressTo = addressDao.findByLocality(country, province, locality);
		
		if (addressDao.existClients(addressTo.getAddressId(), "")) throw new AddressInUseException(addressTo); 
		
		addressDao.remove(addressTo);
		

	}
}
