package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.address.dao.AddressDao;
import gz.cyberbrain.cyberhotel.model.address.to.AddressTo;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.AddressInUseException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Iterator;

public class DeleteAddressByProvinceAction {

	private String country;
	private String province;
	private AddressDao addressDao;

	public DeleteAddressByProvinceAction (String country, String province, AddressDao addressDao) {

		this.country = country;
		this.province = province;
		this.addressDao = addressDao;

	}

	public void execute() throws AddressInUseException, InternalErrorException {	

		Collection values = addressDao.findByProvince(country, province);
		
		Iterator iter = values.iterator();
		AddressTo currentAddress;

		for (int i=0; iter.hasNext(); i++) { 

			currentAddress = (AddressTo) iter.next();
			if (addressDao.existClients(currentAddress.getAddressId(), "")) throw new AddressInUseException(currentAddress); 

		}
		
		iter = null;
		iter = values.iterator();
		
		for (int i=0; iter.hasNext(); i++) { 

			currentAddress = (AddressTo) iter.next();			
			addressDao.remove(currentAddress);		

		}

	}
}
