package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.RoomTypeInUseException;
import gz.cyberbrain.cyberhotel.model.roomtype.dao.RoomTypeDao;
import gz.cyberbrain.cyberhotel.model.roomtype.to.RoomTypeTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteRoomTypeAction {

	private RoomTypeTo roomTypeTo;
	private RoomTypeDao roomTypeDao;
	
	public DeleteRoomTypeAction (RoomTypeTo roomTypeTo, RoomTypeDao roomTypeDao) {
		
		this.roomTypeTo = roomTypeTo;
		this.roomTypeDao = roomTypeDao;
		
	}
	
	public void execute() throws RoomTypeInUseException, InternalErrorException {
		
		if (roomTypeDao.existRooms(roomTypeTo.getRoomTypeCode())) throw new RoomTypeInUseException(roomTypeTo);
		
		roomTypeDao.remove(roomTypeTo);
		
	}
	
}
