package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.SeasonInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.SeasonTariffiedException;
import gz.cyberbrain.cyberhotel.model.season.dao.SeasonDao;
import gz.cyberbrain.cyberhotel.model.season.to.SeasonTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteSeasonAction {

	private SeasonTo seasonTo;
	private SeasonDao seasonDao;

	public DeleteSeasonAction (SeasonTo seasonTo, SeasonDao seasonDao) {

		this.seasonTo = seasonTo;
		this.seasonDao = seasonDao;

	}

	public void execute() throws SeasonInUseException, SeasonTariffiedException, InternalErrorException {

		if (seasonDao.isTariffied(seasonTo.getSeasonId())) throw new SeasonTariffiedException(seasonTo);

		seasonDao.remove(seasonTo);

	}


}
