package gz.cyberbrain.cyberhotel.model.day.dao;

import gz.cyberbrain.cyberhotel.model.day.to.DayTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public interface DayDao {

	public DayTo create(DayTo dayTo) throws InternalErrorException;

	public DayTo find(Calendar dayDate) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (DayTo dayTo) 
		throws InternalErrorException;
	
	public void remove(DayTo dayTo) 
		throws InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findBySeason(Long seasonId) throws InternalErrorException;
	
}
