package gz.cyberbrain.cyberhotel.model.invoice.dao;

import gz.cyberbrain.cyberhotel.model.invoice.to.InvoiceTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface InvoiceDao {

	public InvoiceTo create(InvoiceTo invoiceTo) throws InternalErrorException;

	public InvoiceTo find(Long invoiceNumber, String invoiceSerial) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (InvoiceTo invoiceTo) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void remove(InvoiceTo invoiceTo) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findInvoiceOwes(Long invoiceNumber, String invoiceSerial) throws InternalErrorException;
	
	public Collection findOutstanding() throws InternalErrorException;
	
	public Collection findIssued() throws InternalErrorException;
	
	public boolean payedInvoice(Long invoiceNumber, String invoiceSerial) throws InternalErrorException;
}
