package gz.cyberbrain.cyberhotel.model.invoice.dao;

import gz.cyberbrain.cyberhotel.model.invoice.to.InvoiceTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class InvoiceSpringDao extends AbstractSpringDao implements InvoiceDao {

	public InvoiceSpringDao() {
		super(InvoiceTo.class);
	}	

	public InvoiceTo create(InvoiceTo invoiceTo) throws InternalErrorException {		

		return (InvoiceTo) super.save(invoiceTo);

	}

	public InvoiceTo find(Long invoiceNumber, String invoiceSerial) throws InstanceNotFoundException, InternalErrorException {

		String queryName = "anInvoice";
		Serializable []attributes = {invoiceNumber, invoiceSerial}; 
		Collection invoiceTo = new ArrayList();
		invoiceTo = super.findByAttributes(queryName,attributes);
		Exception e = new Exception("Invoice not unique!");
		if (invoiceTo.size() > 1) throw new InternalErrorException(e);
		if (invoiceTo.size() == 0) throw new InstanceNotFoundException(attributes,InvoiceTo.class.getName());
		Iterator iter = invoiceTo.iterator();
		return (InvoiceTo) iter.next();

	}

	public void update(InvoiceTo invoiceTo) throws InternalErrorException {		

		super.update(invoiceTo);

	}

	public void remove(InvoiceTo invoiceTo) throws InternalErrorException {

		super.delete(invoiceTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allInvoices";
		return super.findByQuery(queryName);

	}

	public Collection findInvoiceOwes(Long invoiceNumber, String invoiceSerial) throws InternalErrorException {

		String queryName = "invoiceOwes";
		Serializable []attributes = {invoiceNumber, invoiceSerial};
		return super.findByAttributes(queryName, attributes);

	}

	public Collection findOutstanding() throws InternalErrorException {
		String queryName = "outstandingInvoices";
		return super.findByQuery(queryName);
	}

	public Collection findIssued() throws InternalErrorException {

		String queryName = "issuedInvoices";
		return super.findByQuery(queryName);
	}

	public boolean payedInvoice(Long invoiceNumber, String invoiceSerial) throws InternalErrorException {
		String queryName = "payedInvoice";
		Serializable []attributes = {invoiceNumber, invoiceSerial};
		Collection payments = super.findByAttributes(queryName, attributes);
		return payments.size() != 0;
	}

}
