package gz.cyberbrain.cyberhotel.model.price.dao;

import gz.cyberbrain.cyberhotel.model.price.to.PriceTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;

public interface PriceDao {
	
	public void create(PriceTo priceTo) throws InternalErrorException;

	public PriceTo find(Long priceId, String board, String priceType, Long season) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void update (PriceTo priceTo) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public void remove(PriceTo priceTo) 
		throws InstanceNotFoundException, InternalErrorException;
	
	public Collection findAll() throws InternalErrorException;
	
	public Collection findBySeason(Long season) throws InternalErrorException;
	
	public long maxId() throws InternalErrorException;

}
