package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableParticularException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class FindOwesByParticularAction {

	private Long particularId;
	private ClientDao particularDao;
	private OweDao oweDao;
	
	public FindOwesByParticularAction (Long particularId, ClientDao particularDao, OweDao oweDao) {
		this.particularId = particularId;
		this.particularDao = particularDao;
		this.oweDao = oweDao;
	}
	
	public Collection execute() throws UnaceptableParticularException, InternalErrorException {
		
		try {
		particularDao.find(particularId);
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableParticularException(particularId);
		}
		
		return oweDao.findByParticular(particularId);
		
	}
	
}
