package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.concept.dao.ConceptDao;
import gz.cyberbrain.cyberhotel.model.invoice.dao.InvoiceDao;
import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.owe.to.OweTo;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RoomNotBusyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableConceptException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableInvoiceException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableParticularException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableRoomException;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class OweAdditionAction {

	private OweTo oweTo;
	private RoomDao roomDao;
	private InvoiceDao invoiceDao;
	private ConceptDao conceptDao;
	private ClientDao particularDao;
	private OweDao oweDao;

	public OweAdditionAction(OweTo oweTo, RoomDao roomDao, InvoiceDao invoiceDao, ConceptDao conceptDao,
			ClientDao particularDao, OweDao oweDao) {
		this.oweTo = oweTo;
		this.roomDao = roomDao;
		this.invoiceDao = invoiceDao;
		this.conceptDao = conceptDao;
		this.particularDao = particularDao;
		this.oweDao = oweDao;

	}

	public OweTo execute() 
	throws UnaceptableRoomException, UnaceptableConceptException, UnaceptableParticularException, 
	UnaceptableInvoiceException, RoomNotBusyException, InstanceNotFoundException, InternalErrorException {

		/*		if (oweTo.getReservation() != null) {
			Exception e = new Exception("Manual reservation assingment to owe!!!");
			throw new InternalErrorException(e);
		}*/	

		if (oweTo.getRoom() == null) throw new UnaceptableRoomException(oweTo.getRoom());

		try {
			roomDao.find(oweTo.getRoom());
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableRoomException(oweTo.getRoom());
		}

		/*Long reservationId;		
		reservationId = roomDao.findCurrentCheckIn(oweTo.getRoom());*/
		//if (oweTo.getReservation()==null) throw new RoomNotBusyException(oweTo.getRoom());

		String status;

		if ((oweTo.getInvoiceNumber() != null)) {

			try {
				invoiceDao.find(oweTo.getInvoiceNumber(), oweTo.getInvoiceSerial());
			} catch (InstanceNotFoundException e) {
				throw new UnaceptableInvoiceException(oweTo.getInvoiceNumber(), oweTo.getInvoiceSerial());
			}

			status = "Facturado";

		} else status = "Pendente";

		try {
			conceptDao.find(oweTo.getConcept()); 		
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableConceptException(oweTo.getConcept());
		}

		if (oweTo.getParticular() == null) {
			//Room owe
		} else {
			//Particular owe (only for stay).
			try {
				particularDao.find(oweTo.getParticular());
			}
			catch (InstanceNotFoundException e) {
				throw new UnaceptableParticularException(oweTo.getParticular());
			}

		}

		oweTo.setStatus(status);

		/*Long oweNumber;
		oweNumber =oweDao.nextOwe(oweTo.getReservation());
 
		oweTo.setOweNumber(oweNumber);*/

		OweTo insertedOwe = oweDao.create(oweTo);

		//oweDao.find(insertedOwe.getOweNumber());		

		return insertedOwe;				

	}

}
