package gz.cyberbrain.cyberhotel.view.swing.edit;

import gz.cyberbrain.cyberhotel.controller.ListAdapter;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.view.swing.FillableWindow;
import gz.cyberbrain.cyberhotel.view.swing.start.MainWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.ListItem;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.JList;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;

import java.awt.Rectangle;
import java.awt.Toolkit;
import java.io.Serializable;

public class ListWindow extends JInternalFrame {

	private static final long serialVersionUID = 1L;

	private FillableWindow addFrame = null;

	private ListAdapter listAdapter = null;  //  @jve:decl-index=0:

	private JPanel jContentPane = null;

	private JList jList = null;

	private JLabel searchLabel = null;

	private JTextField searchTextField = null;

	private JButton searchButton = null;

	private JButton addButton = null;

	private JButton delButton = null; 	

	private InfoPanel infoPanel = null;

	private JScrollPane jScrollPane = null;

	private JButton editButton = null;

	/**
	 * @param owner
	 */
	public ListWindow() {
		super("", false, true, false, true);	
		initialize();
	}	

	public void setChild(FillableWindow addFrame) {
		this.addFrame = addFrame;
	}

	public FillableWindow getChild() {
		return addFrame;
	}

	public void loadList() {
		getJList().setListData(getAdapter().load());
		getEditButton().setEnabled(!getJList().getSize().equals(0));
		getJList().setSelectedIndex(0);
		getInfoPanel().setInfoText(getInfoPanel().getInfoText());
	}

	public void setCellRenderer(ListCellRenderer renderer) {
		getJList().setCellRenderer(renderer);
	}

	public void setAdapter(ListAdapter listAdapter) {
		this.listAdapter = listAdapter;
	}

	public ListAdapter getAdapter() {
		return listAdapter;
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {

		this.setSize(386, 600);		
		this.setLocation(0,0);
		this.setResizable(false);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
		{   

			public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt)
			{        
				clean();
			}
		});	

	}	

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			searchLabel = new JLabel();
			searchLabel.setBounds(new Rectangle(16, 76, 49, 17));
			searchLabel.setText(Locale.get("ListWindow.searchLabel"));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJList(), null);
			jContentPane.add(searchLabel, null);
			jContentPane.add(getSearchTextField(), null);
			jContentPane.add(getSearchButton(), null);
			jContentPane.add(getAddButton(), null);
			jContentPane.add(getDelButton(), null);
			jContentPane.add(getInfoPanel(),null);
			jContentPane.add(getJScrollPane(), null);
			jContentPane.add(getEditButton(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJList() {
		if (jList == null) {
			jList = new JList();
			jList.setBounds(new Rectangle(16, 106, 270, 400));
		}
		return jList;
	}

	/**
	 * This method initializes searchTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getSearchTextField() {
		if (searchTextField == null) {
			searchTextField = new JTextField();
			searchTextField.setBounds(new Rectangle(77, 76, 181, 16));
		}
		return searchTextField;
	}

	/**
	 * This method initializes searchButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSearchButton() {
		if (searchButton == null) {
			searchButton = new JButton();
			searchButton.setBounds(new Rectangle(266, 76, 20, 18));
		}
		return searchButton;
	}

	/**
	 * This method initializes addButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddButton() {
		if (addButton == null) {
			addButton = new JButton();
			addButton.setBounds(new Rectangle(291, 106, 78, 19));
			addButton.setText(Locale.get("ListWindow.addButton"));
			addButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(MainWindow.getInstance()).showInDesktopPane(getChild());
					getChild().clean();
					getChild().setAdapter(getAdapter().getCreator());

				}
			});
		}
		return addButton;
	}

	/**
	 * This method initializes delButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getDelButton() {
		if (delButton == null) {
			delButton = new JButton();
			delButton.setBounds(new Rectangle(291, 135, 78, 19));
			delButton.setText(Locale.get("ListWindow.delButton"));
			delButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					Toolkit.getDefaultToolkit().beep();
					Object[] options = {Locale.get("JOptionPane.Yes"), Locale.get("JOptionPane.No")};
					int n = JOptionPane.showOptionDialog(null,
							Locale.get("JOptionPane.ListWindow.delButton.question"),
							Locale.get("JOptionPane.ListWindow.delButton.title"),
							JOptionPane.YES_NO_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							null,
							options,
							options[1]);

					if (n == JOptionPane.YES_OPTION) {

						Serializable id = ((ListItem)getJList().getSelectedValue()).getId();
						getAdapter().delete(id);
						getJList().setListData(getAdapter().load());
						if (!getJList().getSize().equals(0)) getJList().setSelectedIndex(0);

					}
					showErrors();
				}								
			});
		}
		return delButton;
	}

	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(0,0,this.getWidth(),50);
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);

	}

	public void clean() {
		getSearchTextField().setText("");
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setBounds(new Rectangle(16, 106, 270, 376));
		}
		return jScrollPane;
	}

	/**
	 * This method initializes editButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getEditButton() {
		if (editButton == null) {
			editButton = new JButton();
			editButton.setBounds(new Rectangle(291, 164, 78, 19));
			editButton.setText(Locale.get("ListWindow.editButton"));
			editButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					(MainWindow.getInstance()).showInDesktopPane(getChild());

					getChild().fill(getAdapter().find(((ListItem) getJList().getSelectedValue()).getId()));
					getChild().setAdapter(getAdapter().getUpdater());
					getChild().setId(((ListItem) getJList().getSelectedValue()).getId());

				}
			});
		}
		return editButton;
	}

	private void showErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("delete")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("ListWindow.errors.delete")+ "</html>");							
				Toolkit.getDefaultToolkit().beep();
				ErrorsHandler.clear();
			}			

		}  else getInfoPanel().setInfoText(getInfoPanel().getInfoText());

	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
