package gz.cyberbrain.cyberhotel.view.swing.reception;

import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JPanel;

import gz.cyberbrain.cyberhotel.view.swing.ToolsWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.Payable;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.awt.Rectangle;
import javax.swing.JLabel;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;
import javax.swing.JTextField;
import java.awt.Color;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.IntegerDocument;
import javax.swing.JFormattedTextField;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.DateFormat;

import java.text.ParseException;
import java.util.Calendar;
import java.util.HashMap;
import java.io.Serializable;
import java.lang.String;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;

import javax.swing.JComboBox;
import java.util.Vector;
import gz.cyberbrain.cyberhotel.controller.AgencyListAdapter;
import gz.cyberbrain.cyberhotel.controller.CheckInController;
import gz.cyberbrain.cyberhotel.controller.CompanyListAdapter;
import gz.cyberbrain.cyberhotel.controller.GroupPendingReservationListAdapter;
import gz.cyberbrain.cyberhotel.controller.GroupCheckInListAdapter;
import gz.cyberbrain.cyberhotel.controller.ParticularListAdapter;
import gz.cyberbrain.cyberhotel.controller.RoomListAdapter;
import gz.cyberbrain.cyberhotel.controller.BoardListAdapter;
import gz.cyberbrain.cyberhotel.controller.PriceTypeListAdapter;
import gz.cyberbrain.cyberhotel.controller.SaveAdapter;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;

import javax.swing.DefaultCellEditor;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.UIManager;

import gz.cyberbrain.cyberhotel.view.swing.util.gui.ToolsPanel;

import javax.swing.JTable;
import javax.swing.border.LineBorder;
import javax.swing.text.Document;

import gz.cyberbrain.cyberhotel.view.swing.util.gui.PricesTableModel;

public class GroupCheckInWindow extends ToolsWindow implements Payable {

	private static final long serialVersionUID = 1L;
	private static GroupCheckInWindow groupCheckInWindow = null;
	private Serializable id = null;
	private SaveAdapter saveAdapter = null;
	private Serializable payerId = null;
	private JPanel jContentPane = null;
	private JPanel firstPanel = null;	
	private InfoPanel infoPanel = null;
	private String dialogTitle = null;
	private String dialogMessage = null;	
	private JLabel reservatorNameLabel = null;
	private JTextField reservatorNameTextField = null;
	private JLabel reservatorCifLabel = null;
	private JTextField reservatorCifTextField = null;
	private JLabel reservatorPhoneLabel = null;
	private JTextField reservatorPhoneTextField = null;
	private JLabel incomingDateLabel = null;
	private JFormattedTextField incomingDateTextField = null;
	private JLabel expectedOutgoingDateLabel = null;
	private JFormattedTextField expectedOutgoingDateTextField = null;
	private JLabel trueOutgoingDateLabel = null;
	private JFormattedTextField trueOutgoingDateTextField = null;
	private JLabel payerLabel = null;
	private JLabel agencyLabel = null;
	private JComboBox agencyComboBox = null;
	private JLabel companyLabel = null;
	private JComboBox companyComboBox = null;
	private JComboBox particularComboBox = null;
	private JComboBox roomComboBox = null;
	private JComboBox boardComboBox = null;
	private JComboBox priceTypeComboBox = null;
	private JLabel notesLabel = null;
	private JScrollPane notesScrollPane = null;
	private JTextArea notesTextArea = null;
	private JTextField payerTextField = null;
	private JButton payerButton = null;
	private JButton saveButton = null;
	private JButton cancelButton = null;
	private JLabel reservatorAccountLabel = null;
	private JTextField reservatorAccountTextField = null;
	private JLabel reservatorCardLabel = null;
	private JTextField reservatorCardTextField = null;
	private JLabel statusLabel = null;
	private JComboBox statusComboBox = null;
	private ToolsPanel toolsPanel = null;
	private JScrollPane particularsScrollPane = null;
	private JTable particularsTable = null;
	private JLabel particularsLabel = null;
	private JButton addParticularButton = null;
	private JPanel secondPanel = null;
	private JList reservationsList = null;
	private JLabel reservationsLabel = null;
	private JScrollPane reservationsScrollPane = null;
	private JButton checkInButton = null;

	/**
	 * This is the xxx default constructor
	 */
	private GroupCheckInWindow() {
		super("", false, true, false, true);
		initialize();
	}

	@Override
	public Serializable getId() {
		return id;
	}

	@Override
	public void setId(Serializable id) {
		this.id = id;
	}

	public SaveAdapter getAdapter() {
		return saveAdapter;
	}

	@Override
	public void setAdapter(SaveAdapter saveAdapter) {
		this.saveAdapter = saveAdapter;
	}

	public void setPayerId(Serializable payerId) {
		this.payerId = payerId;
	}

	public Serializable getPayerId() {
		return payerId;
	}

	public void setPayer(Serializable payerId, String payerText) {
		getPayerTextField().setText(payerText);
		setPayerId(payerId);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(956, 660);
		this.setContentPane(getJContentPane());
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
		{

			public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt)
			{
				(IndividualCheckInWindow.getInstance()).clean();
				(IndividualCheckInWindow.getInstance()).lock();
				getToolsPanel().reset();
				groupCheckInWindow = null;
			}
			
		});
		lock();

	}

	/**
	 * This method initializes jContentPane	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getFirstPanel());
			jContentPane.add(getSecondPanel());
		}
		return jContentPane;
	}

	/**
	 * This method initializes firstPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFirstPanel() {
		if (firstPanel == null) {
			firstPanel = new JPanel();
			firstPanel.setLayout(null);
			firstPanel.setSize(new Dimension(706, 660));
			particularsLabel = new JLabel();
			particularsLabel.setBounds(new Rectangle(11, 267, 79, 16));
			particularsLabel.setText(Locale.get("GroupReservationWindow.particularsLabel"));
			statusLabel = new JLabel();
			statusLabel.setBounds(new Rectangle(395, 66, 49, 16));
			statusLabel.setText(Locale.get("GroupReservationWindow.statusLabel"));
			reservatorCardLabel = new JLabel();
			reservatorCardLabel.setBounds(new Rectangle(11, 141, 71, 16));
			reservatorCardLabel.setText(Locale.get("GroupReservationWindow.reservatorCardLabel"));
			reservatorAccountLabel = new JLabel();
			reservatorAccountLabel.setBounds(new Rectangle(11, 116, 71, 16));
			reservatorAccountLabel.setText(Locale.get("GroupReservationWindow.reservatorAccountLabel"));
			notesLabel = new JLabel();
			notesLabel.setBounds(new Rectangle(11, 483, 38, 16));
			notesLabel.setText(Locale.get("GroupReservationWindow.notesLabel"));
			companyLabel = new JLabel();
			companyLabel.setBounds(new Rectangle(11, 243, 54, 16));
			companyLabel.setText(Locale.get("GroupReservationWindow.companyLabel"));
			agencyLabel = new JLabel();
			agencyLabel.setBounds(new Rectangle(11, 214, 54, 16));
			agencyLabel.setText(Locale.get("GroupReservationWindow.agencyLabel"));
			payerLabel = new JLabel();
			payerLabel.setBounds(new Rectangle(11, 182, 54, 16));
			payerLabel.setText(Locale.get("GroupReservationWindow.payerLabel"));
			trueOutgoingDateLabel = new JLabel();
			trueOutgoingDateLabel.setBounds(new Rectangle(537, 66, 74, 16));
			trueOutgoingDateLabel.setText(Locale.get("GroupReservationWindow.trueOutgoingDateLabel"));
			expectedOutgoingDateLabel = new JLabel();
			expectedOutgoingDateLabel.setBounds(new Rectangle(537, 93, 74, 16));
			expectedOutgoingDateLabel.setText(Locale.get("GroupReservationWindow.expectedOutgoingDateLabel"));
			incomingDateLabel = new JLabel();
			incomingDateLabel.setBounds(new Rectangle(395, 93, 49, 16));
			incomingDateLabel.setText(Locale.get("GroupReservationWindow.incomingDateLabel"));
			reservatorPhoneLabel = new JLabel();
			reservatorPhoneLabel.setBounds(new Rectangle(192, 92, 35, 16));
			reservatorPhoneLabel.setText(Locale.get("GroupReservationWindow.reservatorPhoneLabel"));
			reservatorCifLabel = new JLabel();
			reservatorCifLabel.setBounds(new Rectangle(11, 92, 35, 16));
			reservatorCifLabel.setText(Locale.get("GroupReservationWindow.reservatorCifLabel"));
			reservatorNameLabel = new JLabel();
			reservatorNameLabel.setBounds(new Rectangle(11, 66, 71, 16));
			reservatorNameLabel.setText(Locale.get("GroupReservationWindow.reservatorNameLabel"));
			firstPanel.add(getInfoPanel(), null);
			firstPanel.add(reservatorNameLabel, null);
			firstPanel.add(getReservatorNameTextField(), null);
			firstPanel.add(reservatorCifLabel, null);
			firstPanel.add(getReservatorCifTextField(), null);
			firstPanel.add(reservatorPhoneLabel, null);
			firstPanel.add(getReservatorPhoneTextField(), null);
			firstPanel.add(incomingDateLabel, null);
			firstPanel.add(getIncomingDateTextField(), null);
			firstPanel.add(expectedOutgoingDateLabel, null);
			firstPanel.add(getExpectedOutgoingDateTextField(), null);
			firstPanel.add(trueOutgoingDateLabel, null);
			firstPanel.add(getTrueOutgoingDateTextField(), null);
			firstPanel.add(payerLabel, null);
			firstPanel.add(agencyLabel, null);
			firstPanel.add(getAgencyComboBox(), null);
			firstPanel.add(companyLabel, null);
			firstPanel.add(getCompanyComboBox(), null);
			/*firstPanel.add(getParticularComboBox(), null);
			firstPanel.add(getRoomComboBox(), null);
			firstPanel.add(getBoardComboBox(), null);
			firstPanel.add(getPriceTypeComboBox(), null);*/
			firstPanel.add(notesLabel, null);
			firstPanel.add(getNotesScrollPane(), null);
			firstPanel.add(getPayerTextField(), null);
			firstPanel.add(getPayerButton(), null);
			firstPanel.add(getSaveButton(), null);
			firstPanel.add(getCancelButton(), null);
			firstPanel.add(reservatorAccountLabel, null);
			firstPanel.add(getReservatorAccountTextField(), null);
			firstPanel.add(reservatorCardLabel, null);
			firstPanel.add(getReservatorCardTextField(), null);
			firstPanel.add(statusLabel, null);
			firstPanel.add(getStatusComboBox(), null);
			firstPanel.add(getToolsPanel(), null);
			firstPanel.add(getParticularsScrollPane(), null);
			firstPanel.add(particularsLabel, null);
			firstPanel.add(getAddParticularButton(), null);
		}
		return firstPanel;
	}

	/**
	 * This method initializes secondPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSecondPanel() {
		if (secondPanel == null) {
			reservationsLabel = new JLabel();
			reservationsLabel.setBounds(new Rectangle(7, 28, 131, 16));
			reservationsLabel.setText(Locale.get("GroupCheckInWindow.reservationsLabel"));
			secondPanel = new JPanel();
			secondPanel.setLayout(null);
			secondPanel.setBounds(new Rectangle(707, 0, 238, 627));
			secondPanel.setBackground(Color.LIGHT_GRAY);
			secondPanel.add(getReservationsScrollPane(), null);
			secondPanel.add(reservationsLabel, null);
			secondPanel.add(getCheckInButton(), null);
		}
		return secondPanel;
	}

	private void loadList() {
		DefaultListModel model = new DefaultListModel();						
		Vector data = (new GroupPendingReservationListAdapter()).load();
		for (int i=0; i < data.size(); i++) {
			model.add(i, data.elementAt(i));
		}
		reservationsList.setModel(model);
		if (reservationsList.getModel().getSize() != 0) reservationsList.setSelectedIndex(0);

	}

	/**
	 * This method initializes reservationsList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getReservationsList() {
		if (reservationsList == null) {
			reservationsList = new JList();
			reservationsList.setEnabled(false);
			loadList();
		}	

		return reservationsList;
	}

	/**
	 * This method initializes reservationsScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getReservationsScrollPane() {
		if (reservationsScrollPane == null) {
			reservationsScrollPane = new JScrollPane();
			reservationsScrollPane.setBounds(new Rectangle(7, 50, 226, 489));
			reservationsScrollPane.setViewportView(getReservationsList());
		}
		return reservationsScrollPane;
	}

	/**
	 * This method initializes checkInButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCheckInButton() {
		if (checkInButton == null) {
			checkInButton = new JButton();
			checkInButton.setBounds(new Rectangle(7, 549, 76, 17));
			checkInButton.setText(Locale.get("GroupCheckInWindow.checkInButton"));
			checkInButton.setEnabled(false);
			checkInButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					Long reservationId = (Long) ((TextItem) getReservationsList().getSelectedValues()[0]).getId();
					fill((new GroupCheckInListAdapter()).find(reservationId));					
					((DefaultListModel)getReservationsList().getModel()).remove(getReservationsList().getSelectedIndex());
					if (getReservationsList().getModel().getSize() != 0) getReservationsList().setSelectedIndex(0);
					getSaveButton().setEnabled(true);
					getCancelButton().setEnabled(true);
					checkInButton.setEnabled(false);

				}
			});

		}
		return checkInButton;
	}

	/**
	 * This method initializes infoPanel	
	 * 	
	 * @return gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel	
	 */
	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(new Rectangle(0, 0, this.getWidth(), 50));
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		firstPanel.remove(infoPanel);
		infoPanel = ipanel;
		firstPanel.add(infoPanel);

	}

	public String getDialogMessage() {
		return dialogMessage;
	}

	public void setDialogMessage(String dialogMessage) {
		this.dialogMessage = dialogMessage;
	}

	public String getDialogTitle() {
		return dialogTitle;
	}

	public void setDialogTitle(String dialogTitle) {
		this.dialogTitle = dialogTitle;
	}

	public static GroupCheckInWindow getInstance() {
		if (groupCheckInWindow == null) groupCheckInWindow = new GroupCheckInWindow();
		return groupCheckInWindow;
	}
	
	/**
	 * This method initializes reservatorNameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getReservatorNameTextField() {
		if (reservatorNameTextField == null) {
			reservatorNameTextField = new JTextField();
			reservatorNameTextField.setBounds(new Rectangle(90, 65, 286, 20));
			reservatorNameTextField.setBackground(Color.PINK);
		}
		return reservatorNameTextField;
	}

	/**
	 * This method initializes reservatorCifTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getReservatorCifTextField() {
		if (reservatorCifTextField == null) {
			reservatorCifTextField = new JTextField();
			reservatorCifTextField.setBounds(new Rectangle(90, 92, 98, 20));
		}
		return reservatorCifTextField;
	}

	/**
	 * This method initializes reservatorPhoneTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getReservatorPhoneTextField() {
		if (reservatorPhoneTextField == null) {
			reservatorPhoneTextField = new JTextField(new IntegerDocument(15), "", 15);
			reservatorPhoneTextField.setBounds(new Rectangle(235, 92, 141, 20));
			reservatorPhoneTextField.setHorizontalAlignment(JTextField.TRAILING);
		}
		return reservatorPhoneTextField;
	}

	/**
	 * This method initializes incomingDateTextField	
	 * 	
	 * @return javax.swing.JFormattedTextField	
	 */
	private JFormattedTextField getIncomingDateTextField() {
		if (incomingDateTextField == null) {
			try {
				incomingDateTextField = new JFormattedTextField(new DateFormat());
			} catch (ParseException e) {				
				e.printStackTrace();
			}
			incomingDateTextField.setBounds(new Rectangle(451, 93, 80, 20));
		}
		return incomingDateTextField;
	}

	/**
	 * This method initializes expectedOutgoingDateTextField	
	 * 	
	 * @return javax.swing.JFormattedTextField	
	 */
	private JFormattedTextField getExpectedOutgoingDateTextField() {
		if (expectedOutgoingDateTextField == null) {
			try {
				Calendar date = Calendar.getInstance();
				date.add(Calendar.DATE, 1);
				expectedOutgoingDateTextField = new JFormattedTextField(new DateFormat());
				expectedOutgoingDateTextField.setText(DateOperations.calendarToText(date));
				expectedOutgoingDateTextField.addFocusListener(new java.awt.event.FocusAdapter() {
					public void focusLost(java.awt.event.FocusEvent e) {
						getTrueOutgoingDateTextField().setText(DateOperations.calendarToText(DateOperations.textToCalendar(expectedOutgoingDateTextField.getText())));					
					}
				});

			} catch (ParseException e) {
				e.printStackTrace();
			}
			expectedOutgoingDateTextField.setBounds(new Rectangle(616, 93, 75, 20));
		}
		return expectedOutgoingDateTextField;
	}

	/**
	 * This method initializes trueOutgoingDateTextField	
	 * 	
	 * @return javax.swing.JFormattedTextField	
	 */
	private JFormattedTextField getTrueOutgoingDateTextField() {
		if (trueOutgoingDateTextField == null) {
			try {
				Calendar date = Calendar.getInstance();
				date.add(Calendar.DATE, 1);
				trueOutgoingDateTextField = new JFormattedTextField(new DateFormat());
				trueOutgoingDateTextField.setText(DateOperations.calendarToText(date));				
			} catch (ParseException e) {			
				e.printStackTrace();
			}
			trueOutgoingDateTextField.setBounds(new Rectangle(616, 66, 75, 20));
			trueOutgoingDateTextField.setEditable(false);
		}
		return trueOutgoingDateTextField;

	}

	/**
	 * This method initializes agencyComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getAgencyComboBox() {
		if (agencyComboBox == null) {
			Vector agencies = (new AgencyListAdapter()).load();
			agencies.insertElementAt(new TextItem(new Long(0),""), 0);
			agencyComboBox = new JComboBox(agencies);
			agencyComboBox.setBounds(new Rectangle(90, 212, 286, 22));
		}
		return agencyComboBox;	
	}
 
	/**
	 * This method initializes companyComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getCompanyComboBox() {
		if (companyComboBox == null) {
			Vector companies = (new CompanyListAdapter()).load();
			companies.insertElementAt(new TextItem(new Long(0),""), 0);
			companyComboBox = new JComboBox(companies);
			companyComboBox.setBounds(new Rectangle(90, 243, 286, 22));
		}
		return companyComboBox;
	}

	/**
	 * This method initializes particularComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getParticularComboBox() {
		if (particularComboBox == null) {
			Vector particulars = (new ParticularListAdapter()).load();
			particulars.insertElementAt(new TextItem(new Long(0),""), 0);
			particularComboBox = new JComboBox(particulars);
			particularComboBox.setBounds(new Rectangle(90, 300, 286, 22));
		}
		return particularComboBox;
	}

	/**
	 * This method initializes roomComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getRoomComboBox() {
		if (roomComboBox == null) {
			Vector rooms = (new RoomListAdapter()).load();
			rooms.insertElementAt(new TextItem(new String(""),""), 0);
			roomComboBox = new JComboBox(rooms);
			roomComboBox.setBounds(new Rectangle(90, 331, 143, 22));

		}
		return roomComboBox;
	}

	/**
	 * This method initializes boardComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getBoardComboBox() {
		if (boardComboBox == null) {
			Vector boards = (new BoardListAdapter()).load();
			boards.insertElementAt(new TextItem(new String(""),""), 0);
			boardComboBox = new JComboBox(boards);
			boardComboBox.setBounds(new Rectangle(90, 359, 143, 22));
		}
		return boardComboBox;
	}

	/**
	 * This method initializes priceTypeComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getPriceTypeComboBox() {
		if (priceTypeComboBox == null) {
			Vector priceTypes = (new PriceTypeListAdapter()).load();
			priceTypes.insertElementAt(new TextItem(new String(""),""), 0);
			priceTypeComboBox = new JComboBox(priceTypes);
			priceTypeComboBox.setBounds(new Rectangle(90, 386, 143, 22));
		}
		return priceTypeComboBox;
	}

	/**
	 * This method initializes notesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getNotesScrollPane() {
		if (notesScrollPane == null) {
			notesScrollPane = new JScrollPane();
			notesScrollPane.setBounds(new Rectangle(55, 483, 634, 58));
			notesScrollPane.setViewportView(getNotesTextArea());
		}
		return notesScrollPane;
	}

	/**
	 * This method initializes notesTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getNotesTextArea() {
		if (notesTextArea == null) {
			notesTextArea = new JTextArea();
		}
		return notesTextArea;
	}

	/**
	 * This method initializes payerTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPayerTextField() {
		if (payerTextField == null) {
			payerTextField = new JTextField();
			payerTextField.setBounds(new Rectangle(90, 182, 286, 22));
			payerTextField.setEditable(false);
		}
		return payerTextField;
	}

	/**
	 * This method initializes payerButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getPayerButton() {
		if (payerButton == null) {
			payerButton = new JButton();
			payerButton.setBounds(new Rectangle(385, 182, 27, 20));
			payerButton.setText(Locale.get("GroupReservationWindow.payerButton"));
		}
		return payerButton;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setBounds(new Rectangle(525, 548, 76, 17));
			saveButton.setText(Locale.get("GroupReservationWindow.saveButton"));
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					HashMap<String, Serializable> attrs = new HashMap<String, Serializable>();					

					attrs.put("id", (Long) getId());
					attrs.put("reservatorName", getReservatorNameTextField().getText());					           
					attrs.put("reservatorCif", getReservatorCifTextField().getText()); 
					attrs.put("reservatorPhone", getReservatorPhoneTextField().getText());
					attrs.put("reservatorAccount", getReservatorAccountTextField().getText());
					attrs.put("reservatorCard", getReservatorCardTextField().getText());

					String status = null;

					switch (getStatusComboBox().getSelectedIndex()) {
					case 0:
						status = "Pendente";
						break;
					case 1:
						status = "Rexistrada";
						break;
					case 2:
						status = "Anulada";
						break;
					case 3:
						status = "Finalizada";
						break;
					}

					attrs.put("reservationStatus", status); 
					attrs.put("incomingDate", DateOperations.textToCalendar(getIncomingDateTextField().getText()));

					attrs.put("payer", (GroupCheckInWindow.getInstance()).getPayerId());					

					if (getAgencyComboBox().getItemCount() != 0 && ((Long) ((TextItem) getAgencyComboBox().getSelectedItem()).getId() != 0)) attrs.put("agency", ((TextItem) getAgencyComboBox().getSelectedItem()).getId());
					else attrs.put("agency", null);

					if (getCompanyComboBox().getItemCount() != 0 && ((Long) ((TextItem) getCompanyComboBox().getSelectedItem()).getId() != 0)) attrs.put("company", ((TextItem) getCompanyComboBox().getSelectedItem()).getId());
					else attrs.put("company", null);

					attrs.put("notes", getNotesTextArea().getText()); 
					attrs.put("expectedOutgoingDate", DateOperations.textToCalendar(getExpectedOutgoingDateTextField().getText()));
					attrs.put("trueOutgoingDate", DateOperations.textToCalendar(getTrueOutgoingDateTextField().getText()));
					attrs.put("byHours", new Boolean(false));

					/*					Vector <HashMap> requests = new Vector <HashMap> ();

					HashMap <String, Serializable> request = new HashMap <String, Serializable> ();

					if (getParticularComboBox().getItemCount() != 0) 						
						request.put("particular", ((TextItem) getParticularComboBox().getSelectedItem()).getId());
					else request.put("particular", null);						

					if (getRoomComboBox().getItemCount() != 0) request.put("room", ((TextItem) getRoomComboBox().getSelectedItem()).getId());
					else request.put("room", new Long(0));

					if (getBoardComboBox().getItemCount() != 0) request.put("board", ((TextItem) getBoardComboBox().getSelectedItem()).getId());
					else request.put("board", new Long(0));

					if (getPriceTypeComboBox().getItemCount() != 0) request.put("priceType", ((TextItem) getPriceTypeComboBox().getSelectedItem()).getId());
					else request.put("priceType", new Long(0));

					requests.add(request);*/										

					getAdapter().save(attrs);

					if (!inputErrors()) {

						setDialogMessage(Locale.get("JOptionPane.GroupCheckInWindow.saveButton.message"));
						setDialogTitle(Locale.get("JOptionPane.GroupCheckInWindow.saveButton.title"));

						Object[] options = {Locale.get("JOptionPane.Ok")};
						int n = JOptionPane.showOptionDialog(GroupCheckInWindow.getInstance(),
								getDialogMessage(),
								getDialogTitle(),
								JOptionPane.OK_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);

						if (n == JOptionPane.OK_OPTION) {							
							clean();
							lock();
							getToolsPanel().current();
							loadList();
						}																	

					}

				}

			});

		}
		return saveButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setBounds(new Rectangle(612, 548, 77, 17));
			cancelButton.setText(Locale.get("GroupReservationWindow.cancelButton"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(GroupCheckInWindow.getInstance()).clean();

					loadList();

					getSaveButton().setEnabled(false);
					getCancelButton().setEnabled(false);
					if (getReservationsList().getModel().getSize() != 0) getCheckInButton().setEnabled(true);

				}
			});

		}
		return cancelButton;
	}

	/**
	 * This method initializes reservatorAccountTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getReservatorAccountTextField() {
		if (reservatorAccountTextField == null) {
			reservatorAccountTextField = new JTextField();
			reservatorAccountTextField.setBounds(new Rectangle(90, 116, 286, 20));
			reservatorAccountTextField.setHorizontalAlignment(JTextField.TRAILING);
		}
		return reservatorAccountTextField;
	}


	/**
	 * This method initializes reservatorCardTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getReservatorCardTextField() {
		if (reservatorCardTextField == null) {
			Document integerDocument = new IntegerDocument(16);
			reservatorCardTextField = new JTextField(integerDocument, "", 16);
			reservatorCardTextField.setBounds(new Rectangle(90, 141, 286, 20));
			reservatorCardTextField.setHorizontalAlignment(JTextField.TRAILING);
		}
		return reservatorCardTextField;
	}

	/**
	 * This method initializes statusComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getStatusComboBox() {
		if (statusComboBox == null) {
			statusComboBox = new JComboBox();
			statusComboBox.setBounds(new Rectangle(450, 66, 80, 20));
			statusComboBox.addItem(Locale.get("GroupCheckInWindow.statusCombo.item0"));
			statusComboBox.addItem(Locale.get("GroupCheckInWindow.statusCombo.item1"));
			statusComboBox.addItem(Locale.get("GroupCheckInWindow.statusCombo.item2"));
			statusComboBox.addItem(Locale.get("GroupCheckInWindow.statusCombo.item3"));
		}
		return statusComboBox;
	}

	/**
	 * This method initializes toolsPanel	
	 * 	
	 * @return gz.cyberbrain.cyberhotel.view.swing.util.gui.ToolsPanel	
	 */
	private ToolsPanel getToolsPanel() {
		if (toolsPanel == null) {
			toolsPanel = new ToolsPanel(this, new GroupCheckInListAdapter());
			toolsPanel.setBounds(new Rectangle(0, 570, this.getWidth(), 50));
		}
		return toolsPanel;
	}


	/**
	 * This method initializes particularsScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getParticularsScrollPane() {
		if (particularsScrollPane == null) {
			particularsScrollPane = new JScrollPane();
			particularsScrollPane.setBounds(new Rectangle(11, 291, 677, 187));
			particularsScrollPane.setViewportView(getParticularsTable());
		}
		return particularsScrollPane;
	}

	private String[] loadTitles() {
		String [] titles = {
				Locale.get("GroupReservationWindow.particularsTable.firstColumn.title"),
				Locale.get("GroupReservationWindow.particularsTable.secondColumn.title"),
				Locale.get("GroupReservationWindow.particularsTable.thirdColumn.title"),
				Locale.get("GroupReservationWindow.particularsTable.fourthColumn.title"),
		};

		return titles;
	}


	private Object [][] loadData() {

		Object [][] data = null;

		Vector rows = new Vector();

			if (getId() != null) {
				rows = CheckInController.findRequests((Long) getId());				
			}

		data = new Object[rows.size()][4];

		for (int i = 0; i<rows.size(); i++) {

			data[i][0] = (TextItem) ((HashMap) rows.elementAt(i)).get("particular");
			data[i][1] = (TextItem) ((HashMap) rows.elementAt(i)).get("room");
			data[i][2] = (TextItem) ((HashMap) rows.elementAt(i)).get("board");
			data[i][3] = (TextItem) ((HashMap) rows.elementAt(i)).get("priceType");					 
		}

		return data;

	}

	/**
	 * This method initializes particularsTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getParticularsTable() {
		if (particularsTable == null) {

			particularsTable = new JTable();
			particularsTable.setModel(new PricesTableModel(loadData(), loadTitles()));
			if (particularsTable.getRowCount() > 0 ) particularsTable.setRowSelectionInterval(0, 0);			
			particularsTable.getColumnModel().getColumn(0).setCellEditor(new DefaultCellEditor(getParticularComboBox()));
			particularsTable.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(getRoomComboBox()));
			particularsTable.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(getBoardComboBox()));			
			particularsTable.getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(getPriceTypeComboBox()));

			particularsTable.getModel().addTableModelListener(new javax.swing.event.TableModelListener() {

				public void tableChanged(javax.swing.event.TableModelEvent e) {}

			});

		}
		return particularsTable;
	}	

	/**
	 * This method initializes addParticularButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddParticularButton() {
		if (addParticularButton == null) {
			addParticularButton = new JButton();
			addParticularButton.setBounds(new Rectangle(614, 267, 75, 20));
			addParticularButton.setText(Locale.get("GroupReservationWindow.addParticularButton"));
		}
		return addParticularButton;
	}

	private void cleanTable() {

		getParticularsTable().setModel(new PricesTableModel(loadData(), loadTitles()));
		if (getParticularsTable().getRowCount() > 0 ) getParticularsTable().setRowSelectionInterval(0, 0);			
		getParticularsTable().getColumnModel().getColumn(0).setCellEditor(new DefaultCellEditor(getParticularComboBox()));
		getParticularsTable().getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(getRoomComboBox()));
		getParticularsTable().getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(getBoardComboBox()));			
		getParticularsTable().getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(getPriceTypeComboBox()));

		getParticularsTable().getModel().addTableModelListener(new javax.swing.event.TableModelListener() {

			public void tableChanged(javax.swing.event.TableModelEvent e) {}

		});

	}

	
	@Override
	public void cleanErrors() {

		getInfoPanel().setInfoText(getInfoPanel().getInfoText());

		getIncomingDateTextField().setBorder(UIManager.getBorder("TextField.border"));
		getExpectedOutgoingDateTextField().setBorder(UIManager.getBorder("TextField.border"));
		getPayerTextField().setBorder(UIManager.getBorder("TextField.border"));
		getCompanyComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getParticularComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getRoomComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getBoardComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getPriceTypeComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getAgencyComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getStatusComboBox().setBorder(UIManager.getBorder("ComboBox.border"));		

	}

	@Override
	public void lock() {

		getReservatorNameTextField().setEditable(false);
		getReservatorCifTextField().setEditable(false);
		getReservatorPhoneTextField().setEditable(false);
		getReservatorAccountTextField().setEditable(false);
		getReservatorCardTextField().setEditable(false);
		getIncomingDateTextField().setEditable(false);
		getExpectedOutgoingDateTextField().setEditable(false);

		getPayerTextField().setEditable(false);
		getPayerButton().setEnabled(false);		

		getStatusComboBox().setEnabled(false);
		getAgencyComboBox().setEnabled(false);
		getCompanyComboBox().setEnabled(false);
		getAddParticularButton().setEnabled(false);
		getParticularsTable().setEnabled(false);
		getNotesTextArea().setEditable(false);

		getReservationsList().setEnabled(false);
		getCheckInButton().setEnabled(false);
		getSaveButton().setEnabled(false);

		getCancelButton().setEnabled(false);
		getSaveButton().setEnabled(false);

		loadList();

	}

	@Override
	public boolean showErrors() {
		return inputErrors();
	}

	@Override
	public void unlock() {

		getReservationsList().setEnabled(true);
		if (getReservationsList().getModel().getSize() != 0) getCheckInButton().setEnabled(true);

	}

	@Override
	public void update() {
		loadList();
	}

	@Override
	public void clean() {

		setId(null);
		getReservatorNameTextField().setText("");
		getReservatorCifTextField().setText("");
		getReservatorPhoneTextField().setText("");
		getIncomingDateTextField().setText(DateOperations.calendarToText(Calendar.getInstance()));
		if (getStatusComboBox().getItemCount() != 0) getStatusComboBox().setSelectedIndex(0);
		Calendar date = Calendar.getInstance();
		date.add(Calendar.DATE, 1);
		getExpectedOutgoingDateTextField().setText(DateOperations.calendarToText(date));
		getTrueOutgoingDateTextField().setText(DateOperations.calendarToText(date));
		getPayerTextField().setText("");
		setPayer(null,null);
		if (getAgencyComboBox().getItemCount() != 0) getAgencyComboBox().setSelectedIndex(0);
		if (getCompanyComboBox().getItemCount() != 0) getCompanyComboBox().setSelectedIndex(0);
		if (getParticularComboBox().getItemCount() != 0) getParticularComboBox().setSelectedIndex(0);
		if (getRoomComboBox().getItemCount() != 0) getRoomComboBox().setSelectedIndex(0);
		if (getBoardComboBox().getItemCount() != 0) getBoardComboBox().setSelectedIndex(0);
		if (getPriceTypeComboBox().getItemCount() != 0) getPriceTypeComboBox().setSelectedIndex(0);
		cleanTable();
		getNotesTextArea().setText("");

		cleanErrors();


	}

	@Override
	public void fill(HashMap fields) {
		setId((Long) fields.get("id"));
		getReservatorNameTextField().setText((String) fields.get("reservatorName"));
		getReservatorCifTextField().setText((String) fields.get("reservatorCif"));
		getReservatorPhoneTextField().setText((String) fields.get("reservatorPhone"));
		getReservatorAccountTextField().setText((String) fields.get("reservatorAccount"));
		getReservatorCardTextField().setText((String) fields.get("reservatorCard"));
		getIncomingDateTextField().setText(DateOperations.calendarToText((Calendar) fields.get("incomingDate")));
		getExpectedOutgoingDateTextField().setText(DateOperations.calendarToText((Calendar) fields.get("expectedOutgoingDate")));
		getTrueOutgoingDateTextField().setText(DateOperations.calendarToText((Calendar) fields.get("trueOutgoingDate")));

		getPayerTextField().setText(((TextItem) fields.get("payer")).getText());
		setPayer(((TextItem) fields.get("payer")).getId(),((TextItem) fields.get("payer")).getText());

		if (((String) fields.get("reservationStatus")).equals("Pendente")) getStatusComboBox().setSelectedIndex(0);
		if (((String) fields.get("reservationStatus")).equals("Rexistrada")) getStatusComboBox().setSelectedIndex(1);
		if (((String) fields.get("reservationStatus")).equals("Anulada")) getStatusComboBox().setSelectedIndex(2);
		if (((String) fields.get("reservationStatus")).equals("Finalizada")) getStatusComboBox().setSelectedIndex(3);

		for (int i=0; i<getAgencyComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getAgencyComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("agency")).getId())) {
				getAgencyComboBox().setSelectedIndex(i);
			}
		}

		for (int i=0; i<getCompanyComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getCompanyComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("company")).getId())) {
				getCompanyComboBox().setSelectedIndex(i);
			}
		}

		cleanTable();
		
/*		for (int i=0; i<getParticularComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getParticularComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("particular")).getId())) {
				getParticularComboBox().setSelectedIndex(i);
			}
		}

		for (int i=0; i<getRoomComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getRoomComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("room")).getId())) {
				getRoomComboBox().setSelectedIndex(i);
			}
		}

		for (int i=0; i<getBoardComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getBoardComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("board")).getId())) {
				getBoardComboBox().setSelectedIndex(i);
			}
		}

		for (int i=0; i<getPriceTypeComboBox().getItemCount(); i++) {
			TextItem item = (TextItem) getPriceTypeComboBox().getItemAt(i); 
			if ((item.getId()).equals(((TextItem) fields.get("priceType")).getId())) {
				getPriceTypeComboBox().setSelectedIndex(i);
			}
		}*/

		getNotesTextArea().setText((String) fields.get("notes"));

	}

	private boolean inputErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("differentDay")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.differentDay")+ "</html>");

				getIncomingDateTextField().setBorder(new LineBorder(Color.red, 2));
				getExpectedOutgoingDateTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("finishedReservation")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.finishedReservation")+ "</html>");

				getStatusComboBox().setBorder(new LineBorder(Color.red, 2));				
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("priceNotFound")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.priceNotFound")+ "</html>");

				getIncomingDateTextField().setBorder(new LineBorder(Color.red, 2));
				getExpectedOutgoingDateTextField().setBorder(new LineBorder(Color.red, 2));				
				Toolkit.getDefaultToolkit().beep();
				return true;

			}
			
			if (ErrorsHandler.getErrorAt(0).getItem().equals("cancelledReservation")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.cancelledReservation")+ "</html>");

				getStatusComboBox().setBorder(new LineBorder(Color.red, 2));				
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("registeredReservation")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.registeredReservation")+ "</html>");

				getStatusComboBox().setBorder(new LineBorder(Color.red, 2));				
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("roomUnaceptable")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.roomUnaceptable")+ "</html>");

				getRoomComboBox().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("concept")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.concept")+ "</html>");

				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("roomBusy")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.roomBusy")+ "</html>");

				getRoomComboBox().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			} 

			if (ErrorsHandler.getErrorAt(0).getItem().equals("particular")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.particular")+ "</html>");

				getParticularComboBox().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("invoice")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.invoice")+ "</html>");

				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("roomNotBusy")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.roomNotBusy")+ "</html>");

				getRoomComboBox().setBorder(new LineBorder(Color.red, 2));				
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("interval")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.interval")+ "</html>");

				getIncomingDateTextField().setBorder(new LineBorder(Color.red, 2));
				getExpectedOutgoingDateTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("update")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("GroupCheckInWindow.errors.update")+ "</html>");

				Toolkit.getDefaultToolkit().beep();
				return true;

			}

		}

		return false;

	}

}
